> For the complete documentation index, see [llms.txt](https://docs.enzyme.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.enzyme.finance/onyx-protocol/contract-implementations/issuance.md).

# Issuance

## ERC7540LikeDepositQueue

Ordered queue for handling async deposits of a specific asset for shares. Partially compatible with ERC-7540.

Config:

* `asset` : the ERC20 token deposited in exchange for shares
* `minRequestDuration` : minimum time before a request is cancellable
* `depositRestriction` : deposit request restriction
  * `None` : no restrictions
  * `ControllerAllowlist` : in-contract allowlist for depositors

Usage:

* depositors create requests for specific amounts of `asset`
* `asset` amounts for pending requests are escrowed in the queue contract
* admins selectively execute requests; shares are minted to depositors, `asset` amounts of executed requests are moved to `Shares`

Notes:

* Charges entrance fee, if set on `FeeHandler`
* Request execution order and timing is at the discretion of admins
* Whether or not to execute specific requests is at the discretion of admins

## ERC7540LikeRedeemQueue

Ordered queue for handling async redemptions of shares for a specific asset. Partially compatible with ERC-7540.

Config:

* `asset` : the ERC20 token withdrawn in exchange for shares
* `minRequestDuration` : minimum time before a request is cancellable

Usage:

* redeemers create requests for specific amounts of shares
* shares amounts for pending requests are escrowed in the queue contract
* admins selectively execute requests; shares are burned from escrow, `asset` amounts are distributed to redeemers

Notes:

* Charges exit fee, if set on `FeeHandler`
* Request execution order and timing is at the discretion of admins
* Whether or not to execute specific requests is at the discretion of admins


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.enzyme.finance/onyx-protocol/contract-implementations/issuance.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
